# -*- encoding : utf-8 -*-

class Admin::ProductOrdersController < ApplicationController
	before_filter :auth_admin

	layout "admin"


	before_filter :find_product_orders



  def ship
    @product_order = ProductOrder.find(params[:id])
    @product_order.after_ship
    
    redirect_to :back
  end

	def index 

	end


	def edit
		@product_order = ProductOrder.find(params[:id])
	end
  
	
	def show
		@product_order = ProductOrder.find(params[:id])
	end



  def bill
    @product_order = ProductOrder.find(params[:id])
    
    if @product_order.bill_number?
      
      
      
      @temp_file = "#{Rails.root}/pdf/donator_transactions_recus/FACTURE_#{@product_order.id}_temp.pdf"
      @final_file = "#{Rails.root}/pdf/donator_transactions_recus/FACTURE_#{@product_order.id}.pdf"
    
    
      view = ActionView::Base.new(Rails.root.join('app/views'))
      view.class.include ApplicationHelper
      view.class.include Rails.application.routes.url_helpers

      pdf = view.render( 
              :pdf => "#{@product_order.id}",
              :template => "admin/product_orders/bill.html.haml",  
              
              :locals => {:@product_order => @product_order})
                                          
      # then save to a file
      pdf = WickedPdf.new.pdf_from_string(pdf, :margin =>  {   top:               0,                     # default 10 (mm)
                                          bottom:            0,
                                          left:              0,
                                          right:             0 })

      save_path = @temp_file
      File.open(save_path, 'wb') do |file|
      file << pdf
      end
      
      
      
     
      require 'posix/spawn'
     
      ::POSIX::Spawn::Child.new 'pdftk', @temp_file, 'background', Rails.root.join('pdf_stamp', 'facture.pdf').to_s, 'output',  @final_file
    
      #pdftk /Users/nico/Dev/sideplace_app.old/pdf/order_bills/SP20150700003.pdf background fond.pdf output sortie.pdf
      
      
      
      
      
      @data_to_send = File.open( @final_file).read
      
      send_data @data_to_send, :filename =>"facture.pdf" , :type => 'application/pdf',:disposition => (params[:inline] ? 'inline' : "attachment")
  
      
      
      
      
      
      
    else
      render :inline => "Aucune facture disponnible"
    end
    
    
  end



	def create
		@product_order = ProductOrder.new(params.require(:product_order).permit!)


		if @product_order.save
      self.find_product_orders
			flash[:notice] = "La catégorie à été ajouté avec succès."
		

		else
			render :action => "new" 
		
		end
	
	end
	

	def update
		@product_order = ProductOrder.find(params[:id])


		
		
		respond_to do |format|
			if @product_order.update_attributes(params.require(:product_order).permit!)
				
				#ProductOrder.all.each do |mi|
				#	mi.set_permalink
				
				#end
			
				flash[:notice] = "Le menu à été modifié avec succès."
				format.html { redirect_to(admin_product_orders_path(:parent_id => @product_order.parent_id)) }
				if @reorder
					format.js { 
						
						render :action => "update" }
				else
					format.js { 
					   @product_order = ProductOrder.find(@product_order.id)
						render :action => "update_row" }
				end
			else
				
				
					format.html { render :action => "edit" }
					format.js { render :action => "edit" }
			
				
				
			end
		end
    
    
    
    

	end


	def destroy
		@product_order = ProductOrder.find(params[:id])

		@product_order.destroy
    
  
    flash[:notice] = "La commande à bien été supprimée."
	end
	
	
	protected
	
	def find_product_orders    
    @product_orders = ProductOrder.where(:completed_finish => true).order("created_at DESC")
		

	
  end
  
end
